# coding: utf-8
require 'thor'

module Bombard
  class Cli < Thor
    OPTIONS = [:builder, :publisher, :require, :publisher_opts, :builder_opts]

    package_name :bombard
    default_task :default

    # Siege options
    class_option :delay,     type: :string,   aliases: :l,  required: false
    class_option :duration,  type: :string,   aliases: :d,  required: false
    class_option :users,     type: :numeric,  aliases: :u,  required: false
    class_option :agent,     type: :string,   aliases: :A,  required: false
    class_option :header,    type: :string,   aliases: :H,  required: false
    class_option :internet,  type: :boolean,  aliases: :i,  required: false
    class_option :benchmark, type: :boolean,  aliases: :e,  required: false
    class_option :verbose,   type: :boolean,  aliases: :v,  required: false

    # Bombard options
    class_option :builder,        type: :string,  aliases: :b,  required: false
    class_option :publisher,      type: :string,  aliases: :p,  required: false
    class_option :require,        type: :string,  aliases: :r,  required: false
    class_option :publisher_opts, type: :string,  aliases: :P,  required: false
    class_option :builder_opts,   type: :string,  aliases: :B,  required: false

    desc 'default', 'Runs without specifying a task. ie. bombard --etc', hide: true
    def default
      Bombard.start(options.dup)
    end
  end
end
