# coding: utf-8
require 'ostruct'

module Bombard
  class Config
    class << self
      def for(opts)
        new opts
      end
    end

    def initialize(opts)
      @opts = opts
    end

    def siege
      @siege ||= opts_for Siege::OPTIONS.map { |k, _| k }
    end

    def bombard
      @bombard ||= OpenStruct.new opts_for(Bombard::Cli::OPTIONS)
    end

  private

    def opts_for(const)
      @opts.select { |k, _| const.include?(k.to_sym) }.hmap { |k, v| {k.to_sym => v} }
    end
  end
end
